/*****************************************************************************
 * $CAMITK_LICENCE_BEGIN$
 *
 * CamiTK - Computer Assisted Medical Intervention ToolKit
 * (c) 2001-2025 Univ. Grenoble Alpes, CNRS, Grenoble INP - UGA, TIMC, 38000 Grenoble, France
 *
 * Visit http://camitk.imag.fr for more information
 *
 * This file is part of CamiTK.
 *
 * CamiTK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * CamiTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with CamiTK.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $CAMITK_LICENCE_END$
 ****************************************************************************/
#include "UnregisterExtension.h"

#include <Application.h>

#include "HotPlugExtensionManager.h"

#include <QFileInfo>

using namespace camitk;

// -------------------- init --------------------
void UnregisterExtension::init() {
}

// -------------------- process --------------------
Action::ApplyStatus UnregisterExtension::process() {
    QString camitkExtensionFile = getParameterValueAsString("CamiTK File");
    if (camitkExtensionFile.isEmpty() || !QFileInfo(camitkExtensionFile).exists()) {
        return ABORTED;
    }

    if (HotPlugExtensionManager::unregisterExtension(camitkExtensionFile)) {
        refreshApplication(); // to refresh dev menus
        Application::restart("Extension unregistered requires restart");
        return SUCCESS;
    }
    else {
        return WARNING;
    }

}

// -------------------- targetDefined --------------------
void UnregisterExtension::targetDefined() {
}

// -------------------- parameterChanged --------------------
void UnregisterExtension::parameterChanged(QString parameterName) {
}

